stages:
  - validate
  - plan
  - apply
  - verify
  - destroy

image:
  name: hashicorp/terraform:0.12.23
  entrypoint: [""]

variables:
  ENVIRONMENT: staging

before_script:
  - rm -rf .terraform
  - terraform init environments/${ENVIRONMENT}

validate:
  stage: validate
  script: terraform validate environments/${ENVIRONMENT}

plan:
  stage: plan

  script: |
    terraform plan \
      -var project=${PROJECT_ID} \
      environments/${ENVIRONMENT}

apply:
  stage: apply
  only:
    - master
  script: |
    terraform apply \
      -auto-approve \
      -var project=${PROJECT_ID} \
      environments/${ENVIRONMENT}

verify:
  stage: verify
  only:
    - master
  script: |
    terraform plan \
      -var project=${PROJECT_ID} \
      environments/${ENVIRONMENT}

destroy:
  stage: destroy
  only:
    - master
  script: |
    terraform destroy -auto-approve \
      -var project=${PROJECT_ID} \
      environments/${ENVIRONMENT}
  allow_failure: false
  when: manual
